##############################################################################
#
#  Palm-FE Palm Pilot Functional Emulator
#  (c) Vladi Belperchinov-Shabanski "Cade" 2000-2001 
#  <cade@biscom.net> <cade@datamax.bg>
#
#  DISTRIBUTED UNDER GPL LICENSE, SEE `COPYING' FILE FOR DETAILS
#
##############################################################################
package p3_uti;
use CGI;
use p3_ses;
use p3_conf;
use Exporter;
@ISA    = qw( Exporter );
@EXPORT = qw( pipe_image html_expand fmt_table fmt_table2 
              fmt_header fmt_footer 
              edit_categories 
              get_cats_option_list 
              new_id
              rtf_text
              rtf_clean
              rtf_note_reminder );
use strict;

#############################################################################

sub pipe_image
{
  my $name = shift;
  $name =~ s/[^a-z\-\.0-9]//gio;
  local $/ = "";
  my $text = "Content-type: image/gif\n\n";
  open( i, "$ROOT/themes/$THEME/$name" );
  $text .= <i>;
  close( i );
  print $text;
}

#############################################################################

=pod

<-form:method:action>
<-select:name:item1:value1:item2:value2:item3:value3>
<-input:name:length:value>
<-hidden:name:length:value>
<-subimg:name>
<-check:name:1>
<-endf>

<-img:name>

=cut

sub html_expand
{
  $_ = join "", @_;
  s/<-([^>]+)>/tagexp($1)/gie;
  
  # to be a bit more compliant :)
  s|<center>|<div align=center>|gio;
  s|</center>|<div align=center>|gio;
  s|<left>|<div align=left>|gio;
  s|</left>|<div align=left>|gio;
  s|<right>|<div align=right>|gio;
  s|</right>|<div align=right>|gio;
  return $_;
}  

sub tagexp
{
  my @arg = split /:/, shift;
  my $type = shift @arg;
  if ( $type eq "form" )
    {
    return "<form method=$arg[0] action=$arg[1] >";
    }
  elsif( $type eq "endf" )
    {
    return "</form>";
    }  
  elsif( $type eq "select" )
    {
    my $name = shift @arg;
    my $r = "<select name=$name>\n";
    while( $#arg > -1 )
      {
      $r .= "<option name=" . shift( @arg ) . ">" . shift( @arg ) . "</option>\n";
      }
    $r .= "</select>";
    return $r;
    }  
  elsif( $type eq "input" )
    {
    return "<input name=$arg[0] size=$arg[1] value='$arg[2]' >";
    }  
  elsif( $type eq "hidden" )
    {
    return "<input type=hidden name=$arg[0] size=$arg[1] value='$arg[2]' >";
    }  
  elsif( $type eq "check" )
    {
    my $ck = "checked" if $arg[1] > 0;
    return "<input type=checkbox name=$arg[0] $ck>";
    }  
  elsif( $type eq "img" )
    {
    if( $WWWPATH )
      {
      return "<img src='$WWWPATH/$THEME/$arg[0].gif' border=0>";
      }
    else
      {
      return "<img src='$SCR?pipeimg=$arg[0].gif' border=0>";
      }  
    }  
  elsif( $type eq "subimg" )
    {
    if( $WWWPATH )
      {      
      return "<input type=image src='$WWWPATH/$THEME/$arg[0].gif' border=0>";
      }
    else
      {
      return "<input type=image src='$SCR?pipeimg=$arg[0].gif' border=0>";
      }  
    }  
}

#############################################################################

sub fmt_table(\@;$)
{
  my $arr = shift;
  my $opt = shift;
  my $opt_width = $$opt{ width } || "100%";
  my $opt_cellpadding = exists $$opt{ cellpadding } ? $$opt{ cellpadding } : "4";
  my $text = "<table width=$opt_width cellspacing=0 cellpadding=$opt_cellpadding bgcolor=$BGC >\n";
  my $r = 2;
  for( @$arr )
    {
    my $arr_int = $_;
    my $c = ($r == 2) ? $HEC : ( $r ? $TC1 : $TC2 );
    $text .= "<tr bgcolor=$c>";   
    my $opt_right1 = $$opt{ right1 } ? "align=right" : "align=left";
    for( @$arr_int )
      {
      $_ .= "&nbsp;";
      if (/^\+/)
        { s/^\+//; $text .= "<td width=100% $opt_right1>$_</td>"; }
      elsif(/^\=/)
        { s/^\=//; $text .= "<td colspan=2 $opt_right1>$_</td>"; }
      else
        { $text .= "<td $opt_right1>$_</td>"; }  
      $opt_right1 = undef;
      }
    $text .= "</tr>\n";   
    $r = !$r;
    }
    
  $text .= "</table>\n";
  return $text;
}

sub fmt_table2(\@;$)
{
  my $arr = shift;
  my $opt = shift;
  my $opt_width = $$opt{ width } || "100%";
  my $opt_cellpadding = exists $$opt{ cellpadding } ? $$opt{ cellpadding } : "4";
  my $text = "<table width=$opt_width cellspacing=0 cellpadding=$opt_cellpadding>\n";
  for( @$arr )
    {
    my $arr_int = $_;
    $text .= "<tr>";   
    my $opt_right1 = $$opt{ right1 } ? "align=right" : "align=left";
    for( @$arr_int )
      {
      $_ .= "&nbsp;";
      if (/^\+/)
        { s/^\+//; $text .= "<td width=100% $opt_right1>$_</td>"; }
      elsif(/^\=/)
        { s/^\=//; $text .= "<td colspan=2 $opt_right1>$_</td>"; }
      else
        { $text .= "<td $opt_right1>$_</td>"; }  
      $opt_right1 = undef;
      }
    $text .= "</tr>\n";   
    }
    
  $text .= "</table>\n";
  return $text;
}

#############################################################################

sub fmt_header
{
    my $title = shift;

    my $text;
     
    $text .= "Content-type: text/html\n\n";
    
    my $pad = " cellpadding=12 " unless $MODULES{ $MODE }{ cats };
    
    $text .= "
    <html>
    <title>Palm-FE: $MODE $title</title>
    <body bgcolor=$BGC text=$FGC link=$FGC vlink=$FGC alink=$ACC>
    <center>
    <table width=90%>
    <tr>
    <td>
    <!------------------------------------------>
    
      <-form:GET:$SCR>
      <table width=100% $pad>
      <td bgcolor=$FGC width=50%>
        <font size=+1 color=$BGC><b>
        &nbsp;&nbsp;&nbsp;$title
        <a href=$SCR?mode=UserInfo><font color=$BGC>($USER)</font></a>
        </b></font>
      </td>
      <td bgcolor=$BGC width=50% align=right>
        <font color=$FGC>
    ";
    
    if ( $MODULES{ $MODE }{ cats } )
      {
      $text .= "
        <!----------------------------------------------------------->
        <b><select name=cat>
        ";
    
      for( sort keys %CATS )
        {
        my $s_cat = "selected" if $_ eq $CAT;
        $text .= "<option $s_cat>$_</option>";
        }
    
      my $s_all = "selected" if $CAT eq "All";
      my $s_uni = "selected" if $CAT eq "Unified";
      $text .= "
          <option value=All     $s_all>* All</option>
          <option value=Unified $s_uni>* Unified</option>
          <option value=Edit          >* Edit categories...</option>
        </select>
        <input type=submit value=Go></b>
        <!----------------------------------------------------------->
        ";
      }
    else
      {
      $text .= "&nbsp;"; # not required really but just to be sure
      }
    
      $text .= "
        </font>
      </td>
      </table>
      <hr noshade size=2>
      </form>
    
    <!-------------------------------------------------------------->
    </td>
    </tr>
    <tr>
    <td>
    <!--=== header end ===========================================-->
    ";
    
    return $text;
}


sub fmt_footer
{
    my $text;
    
    $text .= "
    <!--=== footer start =========================================-->
    </td>
    <tr>
    <td width=100%>
    <hr noshade size=2>
    <center>
    <table>
    ";
    for( @MODULES )
      {
      my $m = $_;
      my $i = $MODULES{ $m }{ icon };
      $text .= "
        <td>
        <center>
        <a href=$SCR?mode=$m&act=list&cat=Unified><-img:$i><br><b>$m</b></a>
        </center>
        </td>
        ";
      }
    $text .= "
        <td>
        <center>
        <a href=$SCR?username=logout><-img:logout><br><b>Logout</b></a>
        </center>
        </td>
    </table>
    <code><b>" . scalar(localtime()) . "</b><br>
    <font size=-1>Palm-FE3 (c) Vladi Belperchinov-Shabanski 2000 &lt;cade\@datamax.bg&gt;</font>
    </code>
    </center>
    
    </td>
    </table>
    </center>
    
    <!--=== footer end ===========================================-->
    </body>
    </html>
    ";
    
    return $text;
}

#############################################################################

sub edit_categories
{
  my $text;
  
  my $addcat = $SDA{ "in_addcat" };
  my $delcat = $SDA{ "in_delcat" };
  
  $addcat =~ s/[<>]//g;
  $addcat = "\u$addcat";
  
  undef $addcat if $addcat =~ /^(Edit)|(All)|(Unified)$/;
  undef $delcat if $delcat =~ /^(Edit)|(All)|(Unified)$/;
  undef $addcat if $addcat =~ /^\s*$/;
  
  $CATS{ $addcat } = 1 if $addcat;
  delete $CATS{ $delcat } if $delcat;
  
  save_hash( $CATFILE, %CATS );
  
  my @td;
  push @td, [ "+<b>Category name", "<b>Operation" ];
  
  for( sort keys %CATS )
    {
    my $i = $_;
    my $ei = CGI::escape( $i );
    push @td, [ "<b><a href=$SCR?cat=$ei>$i</a></b>", 
                "<a href=$SCR?cat=Edit&delcat=$ei><-img:delete></a>" ];
    }
  
  $text .= "<form action=$SCR?>"
    . fmt_table( @td ) .
    "<center>
     <input type=hidden name=cat  value=Edit>
     <input name=addcat size=30>
     <input type=submit value='Add Category'>
     </form>
     </center>
    ";
  
  return $text;  
};

#############################################################################

sub get_cats_option_list
{
  my $this_cat = shift;
  my $cats_list;
  $cats_list .= "<option>Unified</option>";
  for( keys %CATS )
    {
    my $__;
    if ( $this_cat )
      { $__ = "selected" if $_ eq $this_cat; }
    else
      { $__ = "selected" if $_ eq $CAT; }  
    $cats_list .= "<option $__>$_</option>";
    }
  return $cats_list;
}

#############################################################################

sub new_id
{
  my $id = time();
  while( -e $id ) { $id = time(); }
  return $id;
}

#############################################################################

sub rtf_text
{
  my $text = shift;
  $text =~ s|\*(\S+)\*|<b>$1</b>|gio;
  $text =~ s|\_(\S+)\_|<i>$1</i>|gio;
  $text =~ s|([a-z]+://\S+)|<a href="$1">$1<\/a>|gio;
  $text =~ s|(\S+\@\S+)|<a href="mailto:$1">$1<\/a>|gio;
  return $text;
}

sub rtf_clean
{
  my $text = shift;
  $text =~ s|\*(\S+)\*|$1|gio;
  $text =~ s|\_(\S+)\_|$1|gio;
  return $text;
}

sub rtf_note_reminder
{
  my $text = substr(rtf_clean( shift ), 0, 48);
  return undef unless $text;
  return "<br>$text....."  
}

#############################################################################

1;
