#!/usr/bin/perl -I/home/cade/pro/palm-fe3/pro
##############################################################################
#
#  WARNING!
#
#  The path above should be same as $ROOT one from p3_conf.pm file!
#  i.e. if path that Palm-FE is installed into is:
#
#  /usr/local/palmfe
#
#  then you need to change first line in this file to:
#
#  #!/usr/bin/perl -I/usr/local/palmfe/pro
#
#  and then in p3_conf.pm:
#
#  $ROOT = "/usr/local/palmfe/pro";
#
##############################################################################
#
#  Palm-FE Palm Pilot Functional Emulator
#  (c) Vladi Belperchinov-Shabanski "Cade" 2000-2001 
#  <cade@biscom.net> <cade@datamax.bg>
#
#  DISTRIBUTED UNDER GPL LICENSE, SEE `COPYING' FILE FOR DETAILS
#
#  additional credits here...
#
#
#
#
#
#
#
#
##############################################################################

use CGI;
use p3_ses;
use p3_conf;
use p3_uti;
use strict;

### DYNAMIC IMAGES HACK HERE #################################################

my $pipeimg = CGI::param( "pipeimg" );
if ( $pipeimg ) { pipe_image( $pipeimg ); exit; }

### PROGRAMM STARTS HERE / INITIAL SETUP #####################################

my $errors = undef;

$USER = http_user( PasswdFile => "$ROOT/data/passwd",
                   Domain => "Palm-FE 3",
                   SesPath => "$ROOT/data/sessions/",
                   IdleTime => $IDLE*60 );
$SESS = http_sid();
$SCR = $ENV{ SCRIPT_NAME } . $ENV{ PATH_INFO };

### LOAD CGI PARAMETERS ######################################################

$SDAFILE = "$ROOT/data/sessions/http_ses_$SESS";

load_hash( $SDAFILE, %SDA );
for( keys %SDA )
  {
  delete $SDA{ $_ } if /^in_/;
  }
for( CGI::param() )
  {
  my $value = CGI::param( $_ );
  next if $value =~ /^\s*$/; # skip empty (whitespace only) values
  $value =~ s/[<>\0]//g;
  $SDA{ "in_" . $_ } = $value;
  }

### PRESERVE SPECIALS ###
$SDA{ "mode" } = $SDA{ "in_mode" } if $SDA{ "in_mode" };
$SDA{ "cat" }  = $SDA{ "in_cat" }  if $SDA{ "in_cat" };

### FILL DEFAULTS + VALIDATE ###
$SDA{ "mode" } = "Welcome" unless $SDA{ "mode" };
$SDA{ "cat" }  = "Unified" unless $SDA{ "cat"  };

$errors .= "Invalid ID<br>" unless $SDA{ "in_id" } =~ /^\d*$/;
$errors .= "Invalid MODE name<br>" unless $SDA{ "mode" } =~ /^[a-z_0-9]+$/i;

$CAT  = $SDA{ "cat" };
$MODE = $SDA{ "mode" };
$MODULE = $MODULES{ $MODE }{ file };

save_hash( $SDAFILE, %SDA );

##############################################################################

if ( -r "$ROOT/pro/$MODULE.pm" )
  {
  require "$ROOT/pro/$MODULE.pm";
  }
else
  {
  $errors .= "Module not available (not implemented): $MODE<br>";
  }  

$errors .= "Cannot access DATA directory<br>" unless chdir( "$ROOT/data/users" );

mkdir( $USER, 0700 ) unless -d $USER; 
$errors .= "Cannot access USER directory<br>" unless chdir( "$USER" );
mkdir( $MODE, 0700 ) unless -d $MODE; 
$errors .= "Cannot access MODE directory<br>" unless chdir( "$MODE" );
mkdir( "deleted", 0700 ) unless -d "deleted"; 

load_hash( $CATFILE, %CATS );

my $text;

$text .= fmt_header( $MODE );
if ( $errors )
  {
  $text .= "<center><code><b>ERRORS:<br>$errors</b></code></center><br>";
  }
else  
  {
  load_hash( $CATFILE, %CATS );
  if ( $CAT eq "Edit" )
    {
    $text .= edit_categories();
    }
  else
    {  
    $text .= $MODULE->main();
    save_hash( $SDAFILE, %SDA ); # in case module saved own data
    }
  }
$text .= fmt_footer();

print html_expand( $text );

